! To test the performance of CPU VS GPU on exponetial evaluation
	module cuda_alloc 
	interface 
! cudaHostAlloc 
	integer (C_INT) function cudaHostAlloc(buffer, size)  bind(C,name="cudaHostAlloc")  
	 use ISO_C_BINDING
	 implicit none  
	 type (C_PTR)  :: buffer  
	 integer (C_SIZE_T), value :: size 
         end function cudaHostAlloc
! cudaFreeHost 
	 integer (C_INT) function cudaFreeHost(buffer)  bind(C,name="cudaFreeHost")  
	  use iso_c_binding  
	  implicit none  
	  type (C_PTR), value :: buffer 
	 end function cudaFreeHost 
	 end interface 
	end module cuda_alloc

	Program fmain

        use iso_c_binding
        use cuda_alloc

	implicit none
	integer i, j, N, M
	double precision,allocatable, dimension (:) :: A,B,C
	double precision t1, t2, t3, t4
	double precision error_norm, ref_norm, diff
	double precision ZBQLU01
	integer,parameter::fp_kind=kind(C_double)
        type(C_PTR)::cptr_A,cptr_C
        integer res

	write(*,*)'Input Array Size:'
	read(*,*)N
	write(*,*)'Input runs:'
	read(*,*)M
	allocate(A(N))
	allocate(B(N))
	allocate(C(N))
        
        write(*,*)'Initialization host memory!'
        call initmap()
        res = cudaHostAlloc(cptr_A,N*sizeof(fp_kind))
        call c_f_pointer(cptr_A,A,(/N/))
        res = cudaHostAlloc(cptr_C,N*sizeof(fp_kind))
        call c_f_pointer(cptr_C,C,(/N/))


! Initialize with random numbers
	
	do i = 1, N
		A(i) = -100*ZBQLU01(0.0)
	enddo
! CPU computing	

        write(*,*)'Start computation!'
	Call CPU_TIME(t1)
	do j = 1, M
		do i = 1, N
			B(i) = dexp(A(i))
		enddo
	enddo
	Call CPU_TIME(t2)
	write(*,*)'CPU TIME:', t2 - t1
! GPU computing

	Call CPU_TIME(t3)
	do j = 1, M
		call gexp(cptr_A,cptr_C,N)
	enddo
	Call CPU_TIME(t4)
        write(*,*)'GPU TIME:', t4 - t3
! Compare results
	
	ref_norm = 0.0
	error_norm = 0.0
	do i = 1, N
		diff = C(i) - B(i)
                write(*,*)C(i),B(i)
		error_norm = error_norm + diff**2
		ref_norm = ref_norm + B(i) * B(i)	
	enddo
	error_norm = error_norm**0.5
	ref_norm = ref_norm**0.5
	if (error_norm/ref_norm .gt. 1e-16) then
		write(*,*)'Results on host and device do not match!',error_norm,ref_norm
	else
		write(*,*)'Successfully match host results and device results!',error_norm,ref_norm
	endif
	
	write(*,*)'CPU TIME:', t2 - t1, 'GPU_TIME:',t4 - t3

!	deallocate(A)
!	deallocate(B)
!	deallocate(C)
        res = cudaFreeHost (cptr_A)
        res = cudaFreeHost (cptr_C)
	End
	
